#ifndef PAD_H_INCLUDED
#define PAD_H_INCLUDED

/************************************************************
 *															*
 *						Pad.h								*
 *															*
 *															*
 *	Copyright (C) 1996 Sony Computer Entertainment Inc.		*
 *	All Rights Reserved										*
 *															*
 ***********************************************************/

class CPad
{
protected:
	// low-level pad buffers: never need to touch
	volatile  u_char	*m_bb0 , 
										*m_bb1 ;

public:
	CPad( ) ;
	operator u_long( ) const ;
	u_long getState( ) const ;
};


class CAccellPad
: public CPad
{
public:

	CAccellPad( ) ;
//	~CAccellPad( ) ;

	int	getAccell( ) const ;
};


class CPadCompanion
{
public:
	virtual void servicePad( CPad& p )  ;
};

	// constants for interface
const u_long PADLup     = ( 1<<12);
const u_long PADLdown   = ( 1<<14);
const u_long PADLleft   = ( 1<<15);
const u_long PADLright  = ( 1<<13);
const u_long PADRup     = ( 1<< 4);
const u_long PADRdown   = ( 1<< 6);
const u_long PADRleft   = ( 1<< 7);
const u_long PADRright  = ( 1<< 5);
const u_long PADi       = ( 1<< 9);
const u_long PADj       = ( 1<<10);
const u_long PADk       = ( 1<< 8);
const u_long PADl       = ( 1<< 3);
const u_long PADm       = ( 1<< 1);
const u_long PADn       = ( 1<< 2);
const u_long PADo       = ( 1<< 0);
const u_long PADh       = ( 1<<11);
const u_long PADL1      =PADn ;
const u_long PADL2      =PADo ;
const u_long PADR1      =PADl	;
const u_long PADR2      =PADm	;
const u_long PADstart   =PADh	;
const u_long PADselect  =PADk	;


const u_long PADtriangle = PADRup		;
const u_long PADcross    = PADRdown	;
const u_long PADsquare   = PADRleft	;
const u_long PADcircle   = PADRright;

#endif //PAD_H_INCLUDED